;;;; awk.scm - Support code for awk-syntax

(require 'regex)

(declare
  (hide match? match-s-set! match-a-set! make-match))

(define-record match s a)

(define match:start
  (case-lambda
   [(rec) (match:start rec 0)]
   [(rec which) (car (list-ref (match-a rec) which))]))

(define match:end
  (case-lambda
   [(rec) (match:end rec 0)]
   [(rec which) (cdr (list-ref (match-a rec) which))]))

(define match:substring
  (case-lambda
   [(rec) (match:substring rec 0)]
   [(rec which) (let ([p (list-ref (match-a rec) which)])
		  (substring (match-s rec) (car p) (cdr p)))]))

(define regexp-exec
  (lambda (re s)
    (let ([r (string-search-positions re s)])
      (if r
	  (make-match s (map (lambda (p) (apply cons p)) r))
	  #f))))
